enum CYC {
    //% block="Periodic"
    False,
    //% block="One Shot"
    True
}

//% color="#3ec695" iconWidth=50 iconHeight=40
namespace python_blynk{
  
    //% block="blynk seting server:[SERVER] port:[PORT] AUTH TOKEN:[AUTH_TOKEN]" blockType="command"
    //% SERVER.shadow="string"  SERVER.defl="blynk.mixly.org"    
    //% PORT.shadow="nomber"  PORT.defl="8080"   
    //% AUTH_TOKEN.shadow="string"  AUTH_TOKEN.defl="qlWqWh5SVtYEacjRzALCQ4xnnqopku6T"    
    export function blynkSeting(parameter: any, block: any) {     
        Generator.addImport('import blynklib');
        var server=parameter.SERVER.code;
        var authtoken=parameter.AUTH_TOKEN.code;
        var port=parameter.PORT.code;

        Generator.addCode(`blynk = blynklib.Blynk(${authtoken}, server=${server}, port=${port})`);
        
        Generator.addCode(`
@blynk.handle_event("connect")
def connect_handler():
    print('Blynk connected')      
        
@blynk.handle_event("disconnect")
def connect_handler():
    print('Blynk disconnected')`);

        
    }



    //% block="---"
    export function noteSep1() {

    }



    //% block="register event virtual Pin V[VPIN]" blockType="command"
    //% VPIN.defl="0"       
    export function register_virtual_pin_event_handler(parameter: any, block: any) {
        var vir_pin=parameter.VPIN.code;
        
        Generator.addCode(`
@blynk.handle_event('write V${vir_pin}')
def write_virtual_pin_handler(pin, _value):
    for i in range(0, len(_value)):
        try: _value[i] = eval(_value[i])
        except: pass
    V${vir_pin}_event_recall(_value)
        `,false);        
    
    }   
    


    //% block="event handle virtual Pin V[VPIN]" blockType="hat"
    //% VPIN.defl="0"       
    export function virtual_pin_event_handler(parameter: any, block: any) {
        var vir_pin=parameter.VPIN.code;
        
        Generator.addEvent("event",`V${vir_pin}_event_recall`,"data_received",false);

    
    }   



    //% block="No.[NUMBER]data received" blockType="reporter"
    //% NUMBER.shadow="number"  NUMBER.defl="1"
    export function data_receive(parameter: any, block: any) {
        var num=parameter.NUMBER.code-1;
    Generator.addCode(`data_received[${num}]`,true);

    
    }   



    //% block="---"
    export function noteSep2() {

    }



    //% block="Run blynk process" blockType="command"
    export function blynk_run(parameter: any, block: any) {
        
        Generator.addCode(`blynk.run()`);
        
    }   
    //% block="Please put 'Run blynk  process' in the loop" blockType="command"
    export function put_in_loop1(parameter: any, block: any) {
        Generator.addCode(``);   
        }  


    //% block="---"
    export function noteSep3() {

    }

    

    //% block="send[DATA]to virtual Pin V[VPIN]" blockType="command"
    //% DATA.defl="Data"  VPIN.defl="0"       
    export function send_data_to_virtualPin(parameter: any, block: any) {
        var data=parameter.DATA.code;
        var vir_pin=parameter.VPIN.code;
        
        Generator.addCode(`blynk.virtual_write(${vir_pin}, ${data})`);
    
    }   


    //% block="APP shows notification[NOTIFY]" blockType="command"
    //% NOTIFY.defl="Notify!"  NOTIFY.shadow="string"       
    export function APP_notify(parameter: any, block: any) {
        var notify =parameter.NOTIFY.code;
        
        Generator.addCode(`blynk.notify(${notify})`);
    
    }   


    //% block="---"
    export function noteSep4() {

    }

    
    //% block="---"
    export function noteSep5() {

    }

    //% block="---"
    export function noteSep6() {

    }








    //% block="Register blynk timer[TIMERNO] [CYCLE]cycle[SEC]seconds" blockType="command"
    //% TIMERNO.shadow="number"    TIMERNO.defl="1"         
    //% SEC.shadow="number"
    //% CYCLE.shadow="dropdown"  CYCLE.options="CYC"
    export function register_timer(parameter: any, block: any) {        
        Generator.addImport(`
import blynktimer
blynk_timer = blynktimer.Timer(no_timers_err=False)    
`);

        Generator.addCode(`
@blynk_timer.register(interval=${parameter.SEC.code}, run_once=${parameter.CYCLE.code})
def blynk_timer${parameter.TIMERNO.code}():
    Blynktimer${parameter.TIMERNO.code}_recall()
   `);   
    
    }


    //% block="Blynk timer[TIMERNO] expiring,Execute code:" blockType="hat"
    //% TIMERNO.shadow="number" TIMERNO.defl="1"
    export function blynk_timer_recall(parameter: any, block: any) {        
        Generator.addEvent("event",`Blynktimer${parameter.TIMERNO.code}_recall`,"",false);
    }   



    //% block="Run blynk timer process" blockType="command"
    export function blynk_timer_run(parameter: any, block: any) {        
        Generator.addCode(`blynk_timer.run()`);
    }   
    //% block="Please put 'Run blynk timer process' in the loop" blockType="command"
    export function put_in_loop2(parameter: any, block: any) {
        Generator.addCode(``);   
        }   


    //% block="Stop blynk timer[TIMERNO] process" blockType="command"
    //% TIMERNO.shadow="number" TIMERNO.defl="1"
    export function blynk_timer_stop(parameter: any, block: any) {        
        Generator.addCode(`blynk_timer.stop('${parameter.TIMERNO.code}_blynk_timer${parameter.TIMERNO.code}')`);
    }   

    //% block="Available blynk timer" blockType="reporter"
    export function available_timer(parameter: any, block: any) {
    Generator.addCode(`blynk_timer.get_timers()`);   
    }   


    
    //% block="---"
    export function noteSep6() {

    }

    
        


}
